import { clearFrames } from "../logic/FrameSyncLogic";
import { BattleData } from "../data/BattleData";
import { BombData } from "../data/BombData";
import { PlayerBase } from "../player/PlayerBase";
import { BattleUICtrl } from "../scene/BattleUICtrl";
import { BattleScene } from "../scene/BattleScene";

class BattleMgr {
    /** 战斗界面 */
    public BattleView: BattleScene | null = null;
    public BattleUI: BattleUICtrl | null = null;


    public isFraming: boolean = false;
    public isBattling: boolean = false;

    /**
     * 单例
     */
    private static singleInstance: BattleMgr | null = null;
    static getInstance(): BattleMgr {
        if (BattleMgr.singleInstance == null) {
            BattleMgr.singleInstance = new BattleMgr();
        }
        return BattleMgr.singleInstance;
    }

    public static delInsTan() {
        BattleMgr.singleInstance = null;
    }

    constructor() {
        this.isFraming = false;
        this.isBattling = false;
    }

    /**
     * 所有玩家帧更新开始
     */
    public realInFrame() {
        // this.BattleView?.realInFrame();
        // this.isFraming = true;
    }

    /**
     * 炸弹产生，玩家之间碰撞生效，战斗开始
     */
    public realInBattle(id: number) {
        // let BOMB_DATA = BombData.getInstance();
        // BOMB_DATA.initFrameID = id;
        // this.BattleView?.realInBattle();
        // BOMB_DATA.iSinitBomb = true;
        // this.isBattling = true;
    }

    public gamOver() {
        // if (this.isBattling) {
        //     this.isBattling = false;
        //     this.stopFrameSync();
        //     this.BattleView?.gamOver();
        //     /**
        //      * show settle UI
        //      */
        //     this.BattleView?.sHowSetleUI();
        // }
    }

    /**
     * 发送帧消息
     * SDK
     */
    public sendFrame() {
        let B_DATA = BattleData.getInstance();

        // let players = B_DATA.players;
        // for (let i = 0; i < players.length; i++) {
        //     let p = players[i];
        //     if (!is.Nil(p)) {
        //         if (p.isRobot || p.id == MGOBE.Player.id) {
        //             let sendFramePara = p.sendFrameData();
        //             R_DATA.room.sendFrame(sendFramePara, event => {
        //                 if (event.code === MGOBE.ErrCode.EC_OK) {
        //                 } else {
        //                     console.log(`发送帧消息失败，错误码：${event.code}`);
        //                 }
        //             });
        //         }
        //     }
        // } 

        let myPlayer: PlayerBase | null = B_DATA.myPlayer();
        if (!myPlayer) {
            return;
        }
        myPlayer?.sendFrameData();

    }

    // SDK 开始帧同步
    startFrameSync(CB: Function) {
        // console.log(`正在开始帧同步`);
        // let R_DATA = RoomData.getInstance();
        // R_DATA.room.startFrameSync({}, event => {
        //     if (event.code === MGOBE.ErrCode.EC_OK) {
        //         console.log(`开始帧同步成功：${Date.now()}`);
        //         if (!is.Nil(CB) && is.fn(CB)) {
        //             CB();
        //         }
        //     } else {
        //         console.log(`开始帧同步失败，错误码：${event.code}`);
        //     }
        // });
    }

    // SDK 停止帧同步
    stopFrameSync(success?: () => any) {
        // console.log(`正在停止帧同步`);
        // let R_DATA = RoomData.getInstance();
        // R_DATA.room.stopFrameSync({}, event => {
        //     if (event.code === MGOBE.ErrCode.EC_OK) {
        //         console.log(`停止帧同步成功`);
        //         success && success();
        //     } else {
        //         console.log(`停止帧同步失败，错误码：${event.code}`);
        //     }
        // });
    }

    // // 点击帧同步
    // onFrameSyncTabButtonClick() {
    //     this.changeCustomProperties(SyncType.frame);
    // }

    // onDisable() {
    //     // let R_DATA = RoomData.getInstance();
    //     // // 场景销毁时一定要清理回调，避免引用UI时报错
    //     // R_DATA.room && (R_DATA.room.onUpdate = null);
    //     // // 清理广播回调
    //     // setBroadcastCallbacks(R_DATA.room, this, {});
    //     // // 清理帧缓存
    //     // clearFrames();
    // }

    // /////////////////////////////////// SDK 操作 ///////////////////////////////////
    // // SDK Room 更新回调
    // onRoomUpdate() {
    //     // if (!is.Nil(this.BattleView)) {
    //     //     let R_DATA = RoomData.getInstance();
    //     //     // 如果不在房间内，或者房间已经销毁，回到上一页
    //     //     if (!R_DATA.room || !R_DATA.room.roomInfo || !R_DATA.room.roomInfo.playerList || !R_DATA.room.roomInfo.playerList.find(p => p.id === MGOBE.Player.id)) {
    //     //         // return cc.director.loadScene("mgobe");
    //     //         console.warn('返回匹配界面');
    //     //         this.BattleView.MAIN.openStartNode();
    //     //     }

    //     //     this.BattleView.setRoomView();
    //     // }
    // }

    // // SDK 修改房间自定义信息
    // changeCustomProperties(customProperties: SyncType) {
    //     console.log(`正在修改房间自定义信息为：${customProperties}`);

    //     R_DATA.room.changeRoom({ customProperties }, event => {
    //         if (event.code === MGOBE.ErrCode.EC_OK) {
    //             console.log(`修改房间自定义信息成功`);
    //         } else {
    //             console.log(`修改房间自定义信息失败，错误码：${event.code}`);
    //         }
    //     });
    // }

    // SDK 退出房间
    leaveRoom(CB: Function) {
        console.log(`正在退出房间`);
        // let R_DATA = RoomData.getInstance();
        // R_DATA.room.leaveRoom({}, event => {
        //     if (event.code === MGOBE.ErrCode.EC_OK) {
        //         console.log(`退出房间成功`);
        //         if (CB) {
        //             CB();
        //         }
        //     } else {
        //         console.log(`退出房间失败，错误码：${event.code}`);
        //         if (CB) {
        //             CB();
        //         }
        //     }
        // });
    }

    // SDK 解散房间
    dismissRoom(CB: Function) {
        // console.log(`正在解散房间`);
        // let R_DATA = RoomData.getInstance();
        // R_DATA.room.dismissRoom({}, event => {
        //     if (event.code === MGOBE.ErrCode.EC_OK) {
        //         console.log(`解散房间成功`);
        //         if (CB) {
        //             CB();
        //         }
        //     } else {
        //         console.log(`解散房间失败，错误码：${event.code}`);
        //     }
        // });
    }

    // /////////////////////////////////// SDK 广播 ///////////////////////////////////
    // // SDK 玩家进房广播
    // onJoinRoom(event: MGOBE.types.BroadcastEvent<MGOBE.types.JoinRoomBst>) {
    //     console.log(`广播：玩家进房`);
    // }

    // // SDK 玩家退房广播
    // onLeaveRoom(event: MGOBE.types.BroadcastEvent<MGOBE.types.LeaveRoomBst>) {
    //     console.log(`广播：玩家退房`);
    // }

    // // SDK 房间解散广播
    // onDismissRoom(event: MGOBE.types.BroadcastEvent<MGOBE.types.DismissRoomBst>) {
    //     console.log(`广播：房间解散`);
    //     this.BattleView.MAIN.openStartNode();
    // }

    // SDK 开始帧同步
    onStartFrame() {
        clearFrames();
    }

    // SDK 停止帧同步
    onStopFrame() {
        clearFrames();
    }

    // // SDK 房间内消息广播
    // onRecvFromClient(event: MGOBE.types.BroadcastEvent<MGOBE.types.RecvFromClientBst>) {
    //     // this.uiChat.appendMsg(event.data.msg, event.data.sendPlayerId === MGOBE.Player.id);
    // }

    // // SDK 实时服务器广播
    // onRecvFromGameSvr(event: MGOBE.types.BroadcastEvent<MGOBE.types.RecvFromGameSvrBst>) {
    //     // setState(event.data && event.data.data && event.data.data["players"]);
    // }

    // // SDK 帧同步广播
    // onRecvFrame(event: MGOBE.types.BroadcastEvent<MGOBE.types.RecvFrameBst>) {
    //     console.log('onRecvFrame: ', JSON.stringify(event.data.frame));

    //     // 使用帧广播随机种子和帧ID组成新的随机种子
    //     const seed = event.data.frame.ext.seed + event.data.frame.id;
    //     // 收到帧广播后初始化随机数工具
    //     MGOBE.RandomUtil.init(seed);

    //     for (let i = 0; i < 10; ++i)
    //         console.log('i: ', MGOBE.RandomUtil.random());
    //     pushFrames(event.data.frame);
    //     calcFrame(event.data.frame);
    // }

    // /**
    //  * 初始化最开始的炸弹
    //  */
    // public initBomb(seed: number) {

    // }

    // /**
    //  * 每帧检测玩家炸弹
    //  * @param frameId 
    //  * @returns 
    //  */
    // public updateBomb(frameId: number) {
    //     let B_DATA = BattleData.getInstance();
    //     let BOMB_DATA = BombData.getInstance();
    //     let bombPlayer: PlayerBase | null = B_DATA.bombPlayer();
    //     if (!bombPlayer) {
    //         return;
    //     }
    //     for (let i = 0; i < B_DATA?.players!.length; ++i) {
    //         let p: PlayerBase = B_DATA?.players![i];
    //         if (!p) {
    //             continue;
    //         }
    //         if (p.id !== bombPlayer.id && !p.isFrozen() && BOMB_DATA.iSinitBomb) {
    //             // let cb = bombPlayer.rect();
    //             // let pc = p.rect();
    //             // if (hitTest.Rectangle(cb, pc)) {
    //             //     bombPlayer.setBomb(false, frameId);
    //             //     p.setBomb(true, frameId);
    //             //     break;
    //             // }
    //         }
    //     }
    // }

    // /**
    //  * 
    //  * @param id 
    //  */
    // public svrFramUpt(id: number) {
    //     let B_DATA = BattleData.getInstance();
    //     for (let i = 0; i < B_DATA?.players!.length; ++i) {
    //         let p: PlayerBase = B_DATA?.players![i];
    //         if (!p) {
    //             continue;
    //         }
    //         p.svrFramUpt(id);
    //     }
    // }

}

enum SyncType {
    msg = "房间内发消息",
    state = "实时服务器状态同步",
    frame = "帧同步",
}

export {
    BattleMgr,
    SyncType
}
