import { v3, Vec3 } from "cc";
import { PlayerBase } from "../player/PlayerBase";

class BattleData {
    /** 所有玩家控制脚本 */
    private _players: Array<PlayerBase> | null = null;

    /**
     * 单例
     */
    private static singleInstance: BattleData | null = null;
    static getInstance(): BattleData {
        if (BattleData.singleInstance == null) {
            BattleData.singleInstance = new BattleData();
        }
        return BattleData.singleInstance;
    }

    public static delInsTan() {
        BattleData.singleInstance = null;
    }

    constructor() {
        this._players = [];
    }

    public insertPlayer(player: PlayerBase): void {
        if (!this._players) {
            this._players = [];
        }
        if (player) {
            this._players[this._players?.length] = player;
        }
    }

    public getAllPlayers(): Array<PlayerBase> | null {
        return this._players;
    }

    // /**
    //  * 初始化玩家出生点
    //  * @returns 
    //  */
    // public initPlayersBirthPos(): Array<Vec2> {
    //     let R_DATA = RoomData.getInstance();
    //     let MAP_DATA = MapData.getInstance();
    //     // MGOBE.RandomUtil.init(R_DATA.cReaTime);
    //     // let playerList = R_DATA.room.roomInfo.playerList;

    //     // let len = playerList.length;
    //     let result: Array<Vec2> = [];
    //     // for (let i = 0; i < len; i++) {
    //     //     let idx = Math.floor(MGOBE.RandomUtil.random() * MAP_DATA.validBirthGridLen());
    //     //     let grid = MAP_DATA.getValidBirthGrid(idx);
    //     //     result[i] = MAP_DATA.getPlayerBirthPos(grid);
    //     // }
    //     return result;
    // }

    /**
     * 获取我的玩家
     * @returns 
     */
    public myPlayer(): PlayerBase | null {
        let result: PlayerBase | null = null;
        // if (!is.Nil(this._players) && is.arr(this._players)) {
        //     this._players.some(p => {
        //         if (p.id == MGOBE.Player.id) {
        //             result = p;
        //             return true;
        //         }
        //     });
        // }
        if (this._players) {
            for (let i = 0; i < this._players.length; ++i) {
                let p = this._players[i];
                if (p && true) {
                    result = p;
                    break;
                }
            }
        }
        return result;
    }

    /**
     * 通过ID获取玩家
     * @param id 
     * @returns 
     */
    public player(id: string): PlayerBase | null {
        let result: PlayerBase | null = null;
        // if (!is.Nil(this._players) && is.arr(this._players)) {
        //     this._players.some(p => {
        //         if (p.id == id) {
        //             result = p;
        //             return true;
        //         }
        //     });
        // }
        return result;
    }

    /**
     * 拿炸弹的玩家
     * @returns 
     */
    public bombPlayer(): PlayerBase | null {
        let result: PlayerBase | null = null;
        // if (!is.Nil(this._players) && is.arr(this._players)) {
        //     this._players.some(p => {
        //         if (p.isBomb()) {
        //             result = p;
        //             return true;
        //         }
        //     });
        // }
        return result;
    }

}

const InitBombWaitFrame: number = 4 * 20;    // 逻辑帧为20

/** 摄像机拍摄整个场景时参数 */
const WholeCameraPos: Vec3 = v3(0, 53, 75);
const WholeCameraRotation: Vec3 = v3(-35, 0, 0);
/** 摄像机跟随时参数 */
const FollowCameraPos: Vec3 = v3(0, 30, 42);
const FollowCameraRotation: Vec3 = v3(-35, 0, 0);
/** 摄像机缓动动画duration */
const CameraTweenDuration: number = 1.8;


export {
    BattleData,
    InitBombWaitFrame,
    WholeCameraPos,
    WholeCameraRotation,
    FollowCameraPos,
    FollowCameraRotation,
    CameraTweenDuration,
}
