
import { _decorator, Component, Node, TiledMap, TiledLayer, Vec3 } from 'cc';
import { FrameUtils } from '../../frame/FrameUtils';
import { MapData } from '../data/MapData';
const { ccclass, property } = _decorator;

/**
 * 地图 32*32
 * 由左下角开始
 */
@ccclass('MapCtrl')
export class MapCtrl extends Component {
    public _planeRoot: Node | null = null; // 地板
    public _edgeRoot: Node | null = null;  // 地图边界
    public _staticStoneRoot: Node | null = null;   // 静态石头
    public _dynamicStoneRoot: Node | null = null;  // 动态石头
    public _cylinderRoot: Node | null = null;  // 圆柱障碍
    public _rotateRoot: Node | null = null; // 旋转障碍
    public _playerRoot: Node | null = null;    // 玩家
    public _sendPropRoot: Node | null = null;  // 传送
    public _grassRoot: Node | null = null; // 藏身草地

    onLoad() {
        console.log('Map ctrl onload');

        FrameUtils.bindNode(this.node, this);
        // //
        // let MAP_DATA = MapData.getInstance();
        // this.tileMap = this.node.getComponent(TiledMap);

        // /** tile sets */
        // let _tilesets: Array<object> = this.tileMap!['_tilesets'];
        // if (_tilesets) {
        //     for (let i = 0; i < _tilesets.length; i++) {
        //         let t = _tilesets[i];
        //         switch (t['name']) {
        //             case TileSetsName.stone:
        //                 MAP_DATA.stoneID = t['firstGid'];
        //                 break;
        //             case TileSetsName.grass:
        //                 MAP_DATA.grassID = t['firstGid'];
        //                 break;
        //             default:
        //                 break;
        //         }
        //     }
        // }

        // /** layers */
        // this.stoneTiledLayer = this.tileMap!.getLayer(this._stoneLayer?.name);
        // this.grassTiledLayer = this.tileMap!.getLayer(this._grassLayer?.name);

        // this._storeMapData();
    }

    start() {
        console.log('map ctrl start');

    }

    private _storeMapData() {
        // let MAP_DATA = MapData.getInstance();
        // let tilesStone = this.stoneTiledLayer.getTiles();
        // MAP_DATA.updateStoneData(tilesStone);
        // let tilesGrass = this.grassTiledLayer.getTiles();
        // MAP_DATA.updateGrassData(tilesGrass);
    }

    public addPlayer(player: Node, pos: Vec3): void {
        console.log('map ctrl add player. ');

        if (player) {
            // player.position = pos;
            player.parent = this._playerRoot;
        }
    }
}
