
import { _decorator, Component, Node, Prefab, instantiate, Animation, Vec2, v3, UITransform } from 'cc';
import { FrameUtils } from '../../frame/FrameUtils';
import { ResourceManager } from '../../frame/ResourceManager';
import { BattleMgr } from '../controller/BattleMgr';
import { BattleData } from '../data/BattleData';
import { BombData } from '../data/BombData';
import { GameData } from '../data/GameData';
import { MapData } from '../data/MapData';
import { RoomData } from '../data/RoomData';
import { JoyStick } from '../joystick/JoyStick';

const { ccclass, property } = _decorator;

@ccclass('BattleUICtrl')
export class BattleUICtrl extends Component {
    public MAIN: any = null;

    public _staticRoot: Node | null = null;
    public _uiRoot: Node | null = null;
    public _stickRoot: Node | null = null;

    // public _bg: Node | null = null;

    // public _battleUI: Node | null = null;
    // public _mapBg: Node | null = null;
    // public _tiledMap: Node | null = null;
    // private mapPrefab: Prefab | null = null;
    // private mapCtrl: MapCtrl | null = null;
    // public _joystickRoot: Node | null = null;
    // public _ui: Node | null = null;
    // public _lefTime: Node | null = null;
    // public _top: Node | null = null;

    // /**
    //  * 开始倒计时
    //  */
    // public _countDownStart: Node | null = null;

    /**
     * 静态展示UI
     */
    public _cntDownLabel: Node | null = null;

    /**
     * 摇杆
     */
    private _stickPrefab: Prefab | null = null;
    private _stickNode: Node | null = null;
    private joyStick: JoyStick | null = null;

    // /**
    //  * 玩家
    //  */
    // private _playerPrefab: Prefab | null = null;

    /**
     * 是否正在帧更新
     */
    // public isFrameSync: boolean = false;
    // private lastTimeStamp: number = 0;

    // /**
    //  * 结算
    //  */
    // public _setleUI: Node | null = null;
    // public _setleLabel: Node | null = null;
    // public _setleRestart: Node | null = null;
    // public _setlExit: Node | null = null;

    onLoad() {
        FrameUtils.bindNode(this.node, this);
        // let BATTLE = BattleMgr.getInstance();
        // BATTLE.BattleView = this;
    }

    start() {
        let ResMgr = ResourceManager.getInstance();
        /**
         * preload
         */
        let stick = ResMgr.loadPrefab('prefabs/JoyStick');
        // let player = ResMgr.loadPrefab('prefabs/Player');
        // let map = ResMgr.loadPrefab('prefabs/map/Map0');
        Promise.all([stick]).then((results) => {
            this._stickPrefab = results[0];
            // this._playerPrefab = results[1];
            // this.mapPrefab = results[2];
            // /**
            //  * init map
            //  */
            // this._initMap();
            /**
             * init UI
             */
            this._initUI();
            // this.initPlayers();
            /**
             * 战斗即将开始
             */
            this.prepareBattle();
        });
    }

    update(dt: number) {
        let BATTLE = BattleMgr.getInstance();
        if (BATTLE.isFraming) {
            BATTLE.sendFrame();
            //
            this.upDatePlayerZIdx();
        }
    }

    private _initUI() {
        if (this._stickPrefab && !this._stickNode) {
            let rootHeight = this._stickRoot?.getComponent(UITransform)?.height;
            this._stickNode = instantiate(this._stickPrefab);
            let h = this._stickNode.getComponent(UITransform)?.height;
            this._stickNode.position.set(0, -rootHeight! / 2 + h! / 2 + 50, 0);
            this._stickNode.parent = this._stickRoot;
            this.joyStick = this._stickNode.addComponent(JoyStick);
            this.joyStick?.forbidJoyStick();
        }
    }

    private iNiListner() {
        // let BATTLE = BattleMgr.getInstance();
        // let R_DATA = RoomData.getInstance();
        // // R_DATA.room && (R_DATA.room.onUpdate = () => BATTLE.onRoomUpdate());
        // // // 广播回调
        // // setBroadcastCallbacks(R_DATA.room, this, this as any);
        // /**
        //  * button func
        //  */
        // this._setleRestart?.on(Node.EventType.TOUCH_END, this._sTlRestat.bind(this));
        // this._setlExit?.on(Node.EventType.TOUCH_END, this._sTlExt.bind(this));
    }

    private initPlayers() {
        // let R_DATA = RoomData.getInstance();
        // let B_DATA = BattleData.getInstance();
        // if (R_DATA.room && R_DATA.room.roomInfo && R_DATA.room.roomInfo.playerList) {
        //     let playerList = R_DATA.room.roomInfo.playerList;
        //     /**
        //      * init player position
        //      */
        //     let playersPos: Array<Vec2> = B_DATA.initPlayersBirthPos();

        //     /**
        //      * init players UI
        //      */
        //     for (let i = 0; i < playerList.length; ++i) {
        //         let p = playerList[i];
        //         let isRobot = p['isRobot'];
        //         let pos = playersPos[i];
        //         let player = instantiate(this._playerPrefab);
        //         player.position = v3(pos.x, pos.y, 0);
        //         player.parent = this.mapCtrl._playerBtm;
        //         let pScript: Player = null;
        //         if (isRobot) {
        //             pScript = player.addComponent('PlayeRobot');
        //         }
        //         else {
        //             pScript = player.addComponent('Player');
        //         }
        //         pScript.MAP = this.mapCtrl;
        //         pScript.syncPlayerInfo(p);
        //         B_DATA.players[B_DATA.players.length] = pScript;
        //     }
        // }
    }

    private prepareBattle() {
        let BATTLE = BattleMgr.getInstance();
        let R_DATA = RoomData.getInstance();
        // const roomInfo = R_DATA.room && R_DATA.room.roomInfo || { playerList: [], owner: undefined } as MGOBE.types.RoomInfo;
        // if (roomInfo.owner === MGOBE.Player.id) {
        //     BATTLE.startFrameSync(() => {
        //     });
        // }
    }

    public realInFrame() {
        // let B_DATA = BattleData.getInstance();
        // console.log('realInFrame time: ', Date.now());
        // for (let i = 0; i < B_DATA.players!.length; i++) {
        //     let p: PlayerBase | null = B_DATA.players![i];
        //     if (!p) {
        //         p.isFrameSync = true;
        //     }
        // }

        // // this.isFrameSync = true;
        // this.joyStick?.activeJoyStick();
        // // 倒计时
        // this._countDownStart!.active = true;
        // let ani = this._countDownStart?.getComponent(Animation);
        // if (ani) {
        //     ani.on('finished', () => {

        //     });
        //     ani.play();
        // }
    }

    public realInBattle() {
        let R_DATA = RoomData.getInstance();
        let B_DATA = BattleData.getInstance();
        // // 显示产生炸弹玩家
        // if (R_DATA.room && R_DATA.room.roomInfo && R_DATA.room.roomInfo.playerList) {
        //     let playerList = R_DATA.room.roomInfo.playerList;
        //     let idx = Math.floor(MGOBE.RandomUtil.random() * playerList.length);
        //     let playerId = playerList[idx].id;
        //     let player = B_DATA.player(playerId);
        //     player.setBomb(true);
        // }
    }

    public gamOver() {
        this.joyStick?.forbidJoyStick();

    }

    /**
     * 更新房间信息
     */
    public setRoomView() {
        // let R_DATA = RoomData.getInstance();
        // const roomInfo = R_DATA.room && R_DATA.room.roomInfo || { playerList: [], owner: undefined } as MGOBE.types.RoomInfo;
        // console.log('roomInfo: ', roomInfo);

        // // // 设置文本标签
        // // this.gameIdLlabel.string = global.gameId;
        // // this.playerIdLlabel.string = MGOBE.Player.id;
        // // this.roomIdEditBox.setValue(roomInfo.id || "");
        // // this.onlineLlabel.string = roomInfo.playerList.filter(p => p.commonNetworkState && p.relayNetworkState).length + "" || "0";

        // // // 设置 tips
        // // this.syncTypesLabel.string = roomInfo.customProperties || SyncType.msg;

        // // 设置 tabs 按钮
        // if (roomInfo.owner === MGOBE.Player.id) {
        //     // 房主
        //     console.log('我是房主');

        //     //     this.roomMsgTabButton.node.active =
        //     //         this.stateSyncTabButton.node.active =
        //     //         this.frameSyncTabButton.node.active = true;
        //     //     this.syncTypesLabel.node.active =
        //     //         this.syncTypesTitleLabel.node.active = false;

        //     //     this.leaveRoomButton.node.x = this.dismissRoomButton.node.x - 20 - this.dismissRoomButton.node.width;
        //     //     this.dismissRoomButton.node.active = true;
        // } else {
        //     // 非房主
        //     console.log('我不是房主');

        //     //     this.roomMsgTabButton.node.active =
        //     //         this.stateSyncTabButton.node.active =
        //     //         this.frameSyncTabButton.node.active = false;
        //     //     this.syncTypesLabel.node.active =
        //     //         this.syncTypesTitleLabel.node.active = true;

        //     //     this.leaveRoomButton.node.x = this.dismissRoomButton.node.x;
        //     //     this.dismissRoomButton.node.active = false;
        // }

        // // this.roomMsgTabButton.setActive(this.syncTypesLabel.string === SyncType.msg);
        // // this.stateSyncTabButton.setActive(this.syncTypesLabel.string === SyncType.state);
        // // this.frameSyncTabButton.setActive(this.syncTypesLabel.string === SyncType.frame);

        // // // 设置同步操作界面部分
        // // this.uiChat.node.active = this.roomMsgTabButton.isActive;
        // // this.uiStateSync.node.active = this.stateSyncTabButton.isActive;
        // // this.uiFrameSync.node.active = this.frameSyncTabButton.isActive;

        // // // 设置帧同步按钮状态
        // // this.uiFrameSync.setButtonState(roomInfo.frameSyncState === MGOBE.types.FrameSyncState.START);

        // // // 角色游戏状态
        // // if (roomInfo.customProperties !== SyncType.frame) {
        // //     setDefauleFrameState({ roomInfo } as MGOBE.Room);
        // // }
        // // if (roomInfo.customProperties !== SyncType.state) {
        // //     setDefauleSyncState({ roomInfo } as MGOBE.Room);
        // // }

        // // // 房间人数变化，重新计算帧同步状态
        // // if (roomInfo.playerList.length !== frameSyncState.players.length) {
        // //     reCalcFrameState({ roomInfo } as MGOBE.Room);
        // // }
    }

    private upDatePlayerZIdx() {
        // let B_DATA = BattleData.getInstance();
        // let players = B_DATA.players;
        // let len = players!.length;
        // if (len < 2) {
        //     return;
        // }
        // let pIdx: Array<number> = [];
        // let yPos: Array<number> = [];
        // for (let i = 0; i < len; i++) {
        //     let p = players![i];
        //     yPos[yPos.length] = p.node.y;
        //     pIdx[pIdx.length] = i;
        // }
        // let minYIdx;
        // for (var i = 0; i < len - 1; i++) {
        //     minYIdx = i;
        //     for (var j = i + 1; j < len; j++) {
        //         if (yPos[j] < yPos[minYIdx]) {
        //             minYIdx = j;
        //         }
        //     }
        //     let temp = yPos[i];
        //     yPos[i] = yPos[minYIdx];
        //     yPos[minYIdx] = temp;
        //     //
        //     let idx = pIdx[i];
        //     pIdx[i] = pIdx[minYIdx];
        //     pIdx[minYIdx] = idx;
        // }
        // for (let i = 0; i < pIdx.length; i++) {
        //     let p = players![pIdx[i]];
        //     p.node.zIndex = len - i;
        //     // p.node.getComponent(UITransform)?.priority = len - i;
        // }
    }

    public updateLefTime(id: number) {
        // let BOMB_DATA = BombData.getInstance();
        // let t = (BombFrameCnt - (id - BOMB_DATA.initFrameID)) * 50;
        // let seconds = Math.floor(t / 1000);
        // if (seconds < 0) {
        //     this._lefTime['$Label'].string = '0';
        //     return;
        // }
        // let m = Math.floor(seconds / 60);
        // let s = seconds % 60;
        // let result = '';
        // if (m > 0) {
        //     result = `${m}:`;
        //     result += (s > 9 ? s : `0${s}`);
        // }
        // else {
        //     result = `${s}`;
        // }
        // this._lefTime['$Label'].string = result;
    }

    public sHowSetleUI() {
        // let B_DATA = BattleData.getInstance();
        // let myPlayer = B_DATA.myPlayer();
        // let win = false;
        // if (myPlayer) {
        //     win = !myPlayer.isBomb();
        // }
        // this._setleLabel['$Label'].string = win ? '你赢了' : '你输了';
        // this._setleUI && (this._setleUI.active = true);
    }

    private _sTlRestat() {
        let BATTLE = BattleMgr.getInstance();
        let R_DATA = RoomData.getInstance();
        const eXtFuc = () => {
            BattleData.delInsTan();
            BattleData.delInsTan();
            BombData.delInsTan();
            GameData.delInsTan();
            MapData.delInsTan();
            RoomData.delInsTan();
            //
            this.MAIN.openStartNode();
            this.MAIN.sTartMatch();
        }
        // if (R_DATA.amIOwNr()) {
        //     BATTLE.dismissRoom(eXtFuc);
        // }
        // else {
        //     BATTLE.leaveRoom(eXtFuc);
        // }
    }
    private _sTlExt() {
        let BATTLE = BattleMgr.getInstance();
        let R_DATA = RoomData.getInstance();
        const eXtFuc = () => {
            BattleData.delInsTan();
            BattleData.delInsTan();
            BombData.delInsTan();
            GameData.delInsTan();
            MapData.delInsTan();
            RoomData.delInsTan();
            //
            this.MAIN.openStartNode();
        }
        // if (R_DATA.amIOwNr()) {
        //     BATTLE.dismissRoom(eXtFuc);
        // }
        // else {
        //     BATTLE.leaveRoom(eXtFuc);
        // }
    }
}
