
import { _decorator, Component, Node } from 'cc';
import { FrameUtils } from '../../frame/FrameUtils';
import { CustomEventListener } from '../event/CustomEventListener';
import { EventName } from '../event/EventName';

const { ccclass, property } = _decorator;

@ccclass('UIMain')
export class UIMain extends Component {

    public _startView: Node | null = null;
    public _matchingView: Node | null = null;
    public _battleView: Node | null = null;
    public _settleView: Node | null = null;

    onLoad() {
        FrameUtils.bindNode(this.node, this);
        //
        this._initListener();
    }

    start() {
        this._showStartView();
    }

    private _initListener() {
        CustomEventListener.on(EventName.ShowStartUI, this._showStartView.bind(this));
        CustomEventListener.on(EventName.ShowMatchingUI, this._showMatchingView.bind(this));
        CustomEventListener.on(EventName.ShowBattleUI, this._showBattleView.bind(this));
        CustomEventListener.on(EventName.ShowSettleUI, this._showSettleView.bind(this));
    }

    private _showStartView() {
        this._startView!.active = true;
        this._matchingView!.active = false;
        this._battleView!.active = false;
        this._settleView!.active = false;
    }

    private _showMatchingView() {
        this._startView!.active = false;
        this._matchingView!.active = true;
        this._battleView!.active = false;
        this._settleView!.active = false;
    }

    private _showBattleView() {
        this._startView!.active = false;
        this._matchingView!.active = false;
        this._battleView!.active = true;
        this._settleView!.active = false;

    }

    private _showSettleView() {
        this._startView!.active = false;
        this._matchingView!.active = false;
        this._battleView!.active = false;
        this._settleView!.active = true;

    }

}
